//@author: vux
//@help: standard constant shader
//@tags: color
//@credits: 

Texture2D texture2d; 

SamplerState g_samLinear : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

struct particles
{
		float3 pos;
	float3 vel;
	float3 col;
	float size;
};

StructuredBuffer<particles> pData;

StructuredBuffer<float4> sbColor;

cbuffer cbPerDraw : register( b0 )
{
	float4x4 tW : WORLD;
	float4x4 tWV : WORLD;
	float4x4 tVP : VIEWPROJECTION;
	int colorcount = 1;
};

float4x4 tWVP: WORLDVIEWPROJECTION;
struct VS_IN
{
	uint ii : SV_InstanceID;
	float4 PosO : POSITION;
	float2 TexCd : TEXCOORD0;

};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;	
	float4 Color: TEXCOORD0;
    float2 TexCd: TEXCOORD1;
	float4 Vcol : COLOR2 ;
	
};

vs2ps VS(VS_IN input)
{
    //inititalize all fields of output struct with 0
    vs2ps Out = (vs2ps)0;
	//float3 p = ppos[input.ii].pos; //particle Pos
	float4 p = float4(pData[input.ii].pos,0); //particle Pos
	float3 c = pData[input.ii].col; //particle colour
	float4 pv = mul(input.PosO,tW); //Transform the model
	float4 PosV = pv + p;
	Out.PosWVP =  mul(PosV, tVP);
//	Out.Color = sbColor[input.ii % colorcount];
    Out.TexCd = input.TexCd;
	Out.Vcol = float4(c,1);
    return Out;
}




float4 PS_Tex(vs2ps In): SV_Target
{
    float4 col = texture2d.Sample( g_samLinear, In.TexCd) ;//* In.Color;
   col = col*In.Vcol;
	return col;
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS_Tex() ) );
	}
}




